Index: src/memberdef.cpp
===================================================================
--- src/memberdef.cpp	(revision 840)
+++ src/memberdef.cpp	(working copy)
@@ -1640,16 +1640,65 @@
   if (argsString() && !isObjCMethod()) 
   {
     if (!isDefine()) ol.writeString(" ");
-    linkifyText(TextGeneratorOLImpl(ol), // out
-                d,                       // scope
-                getBodyDef(),            // fileScope
-                this,                    // self
-                argsString(),            // text
-                m_impl->annMemb,         // autoBreak
-                TRUE,                    // external
-                FALSE,                   // keepSpaces
-                s_indentLevel
-               );
+    if (isFunction())
+    {
+        ol.writeString("(");
+        ArgumentListIterator al(*m_impl->declArgList);
+        Argument *arg;
+        int i;
+        for (i = 0; (arg = al.current()); ++al, i++)
+        {
+            if (i != 0)
+                ol.writeString(", ");
+
+            linkifyText(TextGeneratorOLImpl(ol), // out
+                        d,                       // scope
+                        getBodyDef(),            // fileScope
+                        this,                    // self
+                        arg->type,               // text
+                        m_impl->annMemb,         // autoBreak
+                        TRUE,                    // external
+                        FALSE,                   // keepSpaces
+                        s_indentLevel
+                       );
+            if (arg->name.isEmpty())
+                continue;
+            ol.writeString(" ");
+            ol.writeString(arg->name.data());
+            if (!arg->array.isEmpty())
+                ol.writeString(arg->array.data());
+
+            if (!arg->defval.isEmpty())
+            {
+                ol.writeString("=");
+                linkifyText(TextGeneratorOLImpl(ol), // out
+                            d,                       // scope
+                            getBodyDef(),            // fileScope
+                            this,                    // self
+                            arg->defval,               // text
+                            m_impl->annMemb,         // autoBreak
+                            TRUE,                    // external
+                            FALSE,                   // keepSpaces
+                            s_indentLevel
+                           );
+            }
+        }
+        ol.writeString(")");
+    }
+    else
+    {
+        linkifyText(TextGeneratorOLImpl(ol), // out
+                    d,                       // scope
+                    getBodyDef(),            // fileScope
+                    this,                    // self
+                    argsString(),            // text
+                    m_impl->annMemb,         // autoBreak
+                    TRUE,                    // external
+                    FALSE,                   // keepSpaces
+                    s_indentLevel
+                  );
+
+    }
   }
   // *** write exceptions
   if (excpString())
